This documentation is automatically generated by online-judge-tools/verification-helper
View the Project on GitHub maspypy/library
#include "graph/ds/rolling_hash_on_tree.hpp"
#include "random/base.hpp" #include "graph/tree.hpp" #include "mod/modint61.hpp" // 木の辺に文字がちょうどひとつ書いてある (static) template <typename TREE, bool EDGE> struct Rolling_Hash_On_Tree { using mint = modint61; TREE& tree; int N; mint base; // edge に文字があると思って // dp1: [root,v] // dp2: [v,root] vc<int> dat; vc<mint> dp1, dp2; vc<mint> pow, ipow; template <typename F> Rolling_Hash_On_Tree(TREE& tree, F f, mint base_ = 0) : tree(tree), N(tree.N), base(base_) { if (base == mint(0)) base = RNG(mint::get_mod()); build(f); } template <typename F> void build(F f) { dat.resize(N); if constexpr (EDGE) { FOR(i, N - 1) { dat[tree.e_to_v(i)] = f(i); } } else { FOR(i, N) { dat[i] = f(i); } } pow.resize(N + 1), ipow.resize(N + 1); pow[0] = 1, pow[1] = base; ipow[0] = 1, ipow[1] = base.inverse(); FOR(i, 2, N + 1) pow[i] = pow[i - 1] * pow[1]; FOR(i, 2, N + 1) ipow[i] = ipow[i - 1] * ipow[1]; int root = tree.V[0]; dp1.resize(N), dp2.resize(N); dp1[root] = dp2[root] = dat[0]; FOR(i, 1, N) { int v = tree.V[i]; int d = tree.depth[v], p = tree.parent[v]; dp1[v] = base * dp1[p] + dat[v]; dp2[v] = dp2[p] + pow[d] * dat[v]; } } mint get(int a, int b) { int c = tree.lca(a, b); mint x1 = get_du(a, c), x2 = get_ud(c, b); int n2 = tree.depth[b] - tree.depth[c]; if constexpr (!EDGE) { x1 = x1 * base + dat[c]; } return x1 * pow[n2] + x2; } int lcp(int s1, int t1, int s2, int t2) { return lcp_and_comp(s1, t1, s2, t2).fi; } // <=> char comp(int s1, int t1, int s2, int t2) { return lcp_and_comp(s1, t1, s2, t2).se; } pair<int, char> lcp_and_comp(int s1, int t1, int s2, int t2) { int lcp = 0; // heavy path の頂点列 auto path1 = tree.get_path_decomposition(s1, t1, EDGE); auto path2 = tree.get_path_decomposition(s2, t2, EDGE); reverse(all(path1)); reverse(all(path2)); while (len(path1) && len(path2)) { int a, b, c, d; tie(a, b) = POP(path1), tie(c, d) = POP(path2); ll n1 = abs(a - b) + 1, n2 = abs(c - d) + 1; ll n = min(n1, n2); if (n < n1) { if (a <= b) { path1.eb(a + n, b), b = a + n - 1; } if (a > b) { path1.eb(a - n, b), b = a - n + 1; } } if (n < n2) { if (c <= d) { path2.eb(c + n, d), d = c + n - 1; } if (c > d) { path2.eb(c - n, d), d = c - n + 1; } } mint x1 = from_hld_pair(a, b), x2 = from_hld_pair(c, d); if (x1 == x2) { lcp += n; continue; } auto check = [&](ll n) -> bool { if (n == 0) return 1; mint x1 = (a <= b ? from_hld_pair(a, a + n - 1) : from_hld_pair(a, a - n + 1)); mint x2 = (c <= d ? from_hld_pair(c, c + n - 1) : from_hld_pair(c, c - n + 1)); return x1 == x2; }; ll k = binary_search(check, 0, n); lcp += k; a = (a <= b ? a + k : a - k); c = (c <= d ? c + k : c - k); a = tree.V[a], c = tree.V[c]; if (dat[a] < dat[c]) return {lcp, '<'}; if (dat[a] == dat[c]) return {lcp, '='}; if (dat[a] > dat[c]) return {lcp, '>'}; } if (!path1.empty()) return {lcp, '>'}; if (!path2.empty()) return {lcp, '<'}; return {lcp, '='}; } private: mint get_ud(int a, int b) { return (a == -1 ? dp1[b] : dp1[b] - dp1[a] * pow[tree.depth[b] - tree.depth[a]]); } mint get_du(int a, int b) { return (b == -1 ? dp2[a] : (dp2[a] - dp2[b]) * ipow[tree.depth[b] + 1]); } mint from_hld_pair(int a, int b) { if (a <= b) { return get_ud(tree.parent[tree.V[a]], tree.V[b]); } return get_du(tree.V[a], tree.parent[tree.V[b]]); } };
#line 2 "random/base.hpp" u64 RNG_64() { static u64 x_ = u64(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count()) * 10150724397891781847ULL; x_ ^= x_ << 7; return x_ ^= x_ >> 9; } u64 RNG(u64 lim) { return RNG_64() % lim; } ll RNG(ll l, ll r) { return l + RNG_64() % (r - l); } #line 2 "graph/tree.hpp" #line 2 "ds/hashmap.hpp" // u64 -> Val template <typename Val> struct HashMap { // n は入れたいものの個数で ok HashMap(u32 n = 0) { build(n); } void build(u32 n) { u32 k = 8; while (k < n * 2) k *= 2; cap = k / 2, mask = k - 1; key.resize(k), val.resize(k), used.assign(k, 0); } // size を保ったまま. size=0 にするときは build すること. void clear() { used.assign(len(used), 0); cap = (mask + 1) / 2; } int size() { return len(used) / 2 - cap; } int index(const u64& k) { int i = 0; for (i = hash(k); used[i] && key[i] != k; i = (i + 1) & mask) {} return i; } Val& operator[](const u64& k) { if (cap == 0) extend(); int i = index(k); if (!used[i]) { used[i] = 1, key[i] = k, val[i] = Val{}, --cap; } return val[i]; } Val get(const u64& k, Val default_value) { int i = index(k); return (used[i] ? val[i] : default_value); } bool count(const u64& k) { int i = index(k); return used[i] && key[i] == k; } // f(key, val) template <typename F> void enumerate_all(F f) { FOR(i, len(used)) if (used[i]) f(key[i], val[i]); } private: u32 cap, mask; vc<u64> key; vc<Val> val; vc<bool> used; u64 hash(u64 x) { static const u64 FIXED_RANDOM = std::chrono::steady_clock::now().time_since_epoch().count(); x += FIXED_RANDOM; x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9; x = (x ^ (x >> 27)) * 0x94d049bb133111eb; return (x ^ (x >> 31)) & mask; } void extend() { vc<pair<u64, Val>> dat; dat.reserve(len(used) / 2 - cap); FOR(i, len(used)) { if (used[i]) dat.eb(key[i], val[i]); } build(2 * len(dat)); for (auto& [a, b]: dat) (*this)[a] = b; } }; #line 3 "graph/base.hpp" template <typename T> struct Edge { int frm, to; T cost; int id; }; template <typename T = int, bool directed = false> struct Graph { static constexpr bool is_directed = directed; int N, M; using cost_type = T; using edge_type = Edge<T>; vector<edge_type> edges; vector<int> indptr; vector<edge_type> csr_edges; vc<int> vc_deg, vc_indeg, vc_outdeg; bool prepared; class OutgoingEdges { public: OutgoingEdges(const Graph* G, int l, int r) : G(G), l(l), r(r) {} const edge_type* begin() const { if (l == r) { return 0; } return &G->csr_edges[l]; } const edge_type* end() const { if (l == r) { return 0; } return &G->csr_edges[r]; } private: const Graph* G; int l, r; }; bool is_prepared() { return prepared; } Graph() : N(0), M(0), prepared(0) {} Graph(int N) : N(N), M(0), prepared(0) {} void build(int n) { N = n, M = 0; prepared = 0; edges.clear(); indptr.clear(); csr_edges.clear(); vc_deg.clear(); vc_indeg.clear(); vc_outdeg.clear(); } void add(int frm, int to, T cost = 1, int i = -1) { assert(!prepared); assert(0 <= frm && 0 <= to && to < N); if (i == -1) i = M; auto e = edge_type({frm, to, cost, i}); edges.eb(e); ++M; } #ifdef FASTIO // wt, off void read_tree(bool wt = false, int off = 1) { read_graph(N - 1, wt, off); } void read_graph(int M, bool wt = false, int off = 1) { for (int m = 0; m < M; ++m) { INT(a, b); a -= off, b -= off; if (!wt) { add(a, b); } else { T c; read(c); add(a, b, c); } } build(); } #endif void build() { assert(!prepared); prepared = true; indptr.assign(N + 1, 0); for (auto&& e: edges) { indptr[e.frm + 1]++; if (!directed) indptr[e.to + 1]++; } for (int v = 0; v < N; ++v) { indptr[v + 1] += indptr[v]; } auto counter = indptr; csr_edges.resize(indptr.back() + 1); for (auto&& e: edges) { csr_edges[counter[e.frm]++] = e; if (!directed) csr_edges[counter[e.to]++] = edge_type({e.to, e.frm, e.cost, e.id}); } } OutgoingEdges operator[](int v) const { assert(prepared); return {this, indptr[v], indptr[v + 1]}; } vc<int> deg_array() { if (vc_deg.empty()) calc_deg(); return vc_deg; } pair<vc<int>, vc<int>> deg_array_inout() { if (vc_indeg.empty()) calc_deg_inout(); return {vc_indeg, vc_outdeg}; } int deg(int v) { if (vc_deg.empty()) calc_deg(); return vc_deg[v]; } int in_deg(int v) { if (vc_indeg.empty()) calc_deg_inout(); return vc_indeg[v]; } int out_deg(int v) { if (vc_outdeg.empty()) calc_deg_inout(); return vc_outdeg[v]; } #ifdef FASTIO void debug() { print("Graph"); if (!prepared) { print("frm to cost id"); for (auto&& e: edges) print(e.frm, e.to, e.cost, e.id); } else { print("indptr", indptr); print("frm to cost id"); FOR(v, N) for (auto&& e: (*this)[v]) print(e.frm, e.to, e.cost, e.id); } } #endif vc<int> new_idx; vc<bool> used_e; // G における頂点 V[i] が、新しいグラフで i になるようにする // {G, es} // sum(deg(v)) の計算量になっていて、 // 新しいグラフの n+m より大きい可能性があるので注意 Graph<T, directed> rearrange(vc<int> V, bool keep_eid = 0) { if (len(new_idx) != N) new_idx.assign(N, -1); int n = len(V); FOR(i, n) new_idx[V[i]] = i; Graph<T, directed> G(n); vc<int> history; FOR(i, n) { for (auto&& e: (*this)[V[i]]) { if (len(used_e) <= e.id) used_e.resize(e.id + 1); if (used_e[e.id]) continue; int a = e.frm, b = e.to; if (new_idx[a] != -1 && new_idx[b] != -1) { history.eb(e.id); used_e[e.id] = 1; int eid = (keep_eid ? e.id : -1); G.add(new_idx[a], new_idx[b], e.cost, eid); } } } FOR(i, n) new_idx[V[i]] = -1; for (auto&& eid: history) used_e[eid] = 0; G.build(); return G; } Graph<T, true> to_directed_tree(int root = -1) { if (root == -1) root = 0; assert(!is_directed && prepared && M == N - 1); Graph<T, true> G1(N); vc<int> par(N, -1); auto dfs = [&](auto& dfs, int v) -> void { for (auto& e: (*this)[v]) { if (e.to == par[v]) continue; par[e.to] = v, dfs(dfs, e.to); } }; dfs(dfs, root); for (auto& e: edges) { int a = e.frm, b = e.to; if (par[a] == b) swap(a, b); assert(par[b] == a); G1.add(a, b, e.cost); } G1.build(); return G1; } HashMap<int> MP_FOR_EID; int get_eid(u64 a, u64 b) { if (len(MP_FOR_EID) == 0) { MP_FOR_EID.build(N - 1); for (auto& e: edges) { u64 a = e.frm, b = e.to; u64 k = to_eid_key(a, b); MP_FOR_EID[k] = e.id; } } return MP_FOR_EID.get(to_eid_key(a, b), -1); } u64 to_eid_key(u64 a, u64 b) { if (!directed && a > b) swap(a, b); return N * a + b; } private: void calc_deg() { assert(vc_deg.empty()); vc_deg.resize(N); for (auto&& e: edges) vc_deg[e.frm]++, vc_deg[e.to]++; } void calc_deg_inout() { assert(vc_indeg.empty()); vc_indeg.resize(N); vc_outdeg.resize(N); for (auto&& e: edges) { vc_indeg[e.to]++, vc_outdeg[e.frm]++; } } }; #line 4 "graph/tree.hpp" // HLD euler tour をとっていろいろ。 template <typename GT> struct Tree { using Graph_type = GT; GT &G; using WT = typename GT::cost_type; int N; vector<int> LID, RID, head, V, parent, VtoE; vc<int> depth; vc<WT> depth_weighted; Tree(GT &G, int r = 0, bool hld = 1) : G(G) { build(r, hld); } void build(int r = 0, bool hld = 1) { if (r == -1) return; // build を遅延したいとき N = G.N; LID.assign(N, -1), RID.assign(N, -1), head.assign(N, r); V.assign(N, -1), parent.assign(N, -1), VtoE.assign(N, -1); depth.assign(N, -1), depth_weighted.assign(N, 0); assert(G.is_prepared()); int t1 = 0; dfs_sz(r, -1, hld); dfs_hld(r, t1); } void dfs_sz(int v, int p, bool hld) { auto &sz = RID; parent[v] = p; depth[v] = (p == -1 ? 0 : depth[p] + 1); sz[v] = 1; int l = G.indptr[v], r = G.indptr[v + 1]; auto &csr = G.csr_edges; // 使う辺があれば先頭にする for (int i = r - 2; i >= l; --i) { if (hld && depth[csr[i + 1].to] == -1) swap(csr[i], csr[i + 1]); } int hld_sz = 0; for (int i = l; i < r; ++i) { auto e = csr[i]; if (depth[e.to] != -1) continue; depth_weighted[e.to] = depth_weighted[v] + e.cost; VtoE[e.to] = e.id; dfs_sz(e.to, v, hld); sz[v] += sz[e.to]; if (hld && chmax(hld_sz, sz[e.to]) && l < i) { swap(csr[l], csr[i]); } } } void dfs_hld(int v, int ×) { LID[v] = times++; RID[v] += LID[v]; V[LID[v]] = v; bool heavy = true; for (auto &&e: G[v]) { if (depth[e.to] <= depth[v]) continue; head[e.to] = (heavy ? head[v] : e.to); heavy = false; dfs_hld(e.to, times); } } vc<int> heavy_path_at(int v) { vc<int> P = {v}; while (1) { int a = P.back(); for (auto &&e: G[a]) { if (e.to != parent[a] && head[e.to] == v) { P.eb(e.to); break; } } if (P.back() == a) break; } return P; } int heavy_child(int v) { int k = LID[v] + 1; if (k == N) return -1; int w = V[k]; return (parent[w] == v ? w : -1); } int e_to_v(int eid) { auto e = G.edges[eid]; return (parent[e.frm] == e.to ? e.frm : e.to); } int v_to_e(int v) { return VtoE[v]; } int get_eid(int u, int v) { if (parent[u] != v) swap(u, v); assert(parent[u] == v); return VtoE[u]; } int ELID(int v) { return 2 * LID[v] - depth[v]; } int ERID(int v) { return 2 * RID[v] - depth[v] - 1; } // 目標地点へ進む個数が k int LA(int v, int k) { assert(k <= depth[v]); while (1) { int u = head[v]; if (LID[v] - k >= LID[u]) return V[LID[v] - k]; k -= LID[v] - LID[u] + 1; v = parent[u]; } } int la(int u, int v) { return LA(u, v); } int LCA(int u, int v) { for (;; v = parent[head[v]]) { if (LID[u] > LID[v]) swap(u, v); if (head[u] == head[v]) return u; } } int meet(int a, int b, int c) { return LCA(a, b) ^ LCA(a, c) ^ LCA(b, c); } int lca(int u, int v) { return LCA(u, v); } int subtree_size(int v, int root = -1) { if (root == -1) return RID[v] - LID[v]; if (v == root) return N; int x = jump(v, root, 1); if (in_subtree(v, x)) return RID[v] - LID[v]; return N - RID[x] + LID[x]; } int dist(int a, int b) { int c = LCA(a, b); return depth[a] + depth[b] - 2 * depth[c]; } WT dist_weighted(int a, int b) { int c = LCA(a, b); return depth_weighted[a] + depth_weighted[b] - WT(2) * depth_weighted[c]; } // a is in b bool in_subtree(int a, int b) { return LID[b] <= LID[a] && LID[a] < RID[b]; } int jump(int a, int b, ll k) { if (k == 1) { if (a == b) return -1; return (in_subtree(b, a) ? LA(b, depth[b] - depth[a] - 1) : parent[a]); } int c = LCA(a, b); int d_ac = depth[a] - depth[c]; int d_bc = depth[b] - depth[c]; if (k > d_ac + d_bc) return -1; if (k <= d_ac) return LA(a, k); return LA(b, d_ac + d_bc - k); } vc<int> collect_child(int v) { vc<int> res; for (auto &&e: G[v]) if (e.to != parent[v]) res.eb(e.to); return res; } vc<int> collect_light(int v) { vc<int> res; bool skip = true; for (auto &&e: G[v]) if (e.to != parent[v]) { if (!skip) res.eb(e.to); skip = false; } return res; } vc<pair<int, int>> get_path_decomposition(int u, int v, bool edge) { // [始点, 終点] の"閉"区間列。 vc<pair<int, int>> up, down; while (1) { if (head[u] == head[v]) break; if (LID[u] < LID[v]) { down.eb(LID[head[v]], LID[v]); v = parent[head[v]]; } else { up.eb(LID[u], LID[head[u]]); u = parent[head[u]]; } } if (LID[u] < LID[v]) down.eb(LID[u] + edge, LID[v]); elif (LID[v] + edge <= LID[u]) up.eb(LID[u], LID[v] + edge); reverse(all(down)); up.insert(up.end(), all(down)); return up; } // 辺の列の情報 (frm,to,str) // str = "heavy_up", "heavy_down", "light_up", "light_down" vc<tuple<int, int, string>> get_path_decomposition_detail(int u, int v) { vc<tuple<int, int, string>> up, down; while (1) { if (head[u] == head[v]) break; if (LID[u] < LID[v]) { if (v != head[v]) down.eb(head[v], v, "heavy_down"), v = head[v]; down.eb(parent[v], v, "light_down"), v = parent[v]; } else { if (u != head[u]) up.eb(u, head[u], "heavy_up"), u = head[u]; up.eb(u, parent[u], "light_up"), u = parent[u]; } } if (LID[u] < LID[v]) down.eb(u, v, "heavy_down"); elif (LID[v] < LID[u]) up.eb(u, v, "heavy_up"); reverse(all(down)); concat(up, down); return up; } vc<int> restore_path(int u, int v) { vc<int> P; for (auto &&[a, b]: get_path_decomposition(u, v, 0)) { if (a <= b) { FOR(i, a, b + 1) P.eb(V[i]); } else { FOR_R(i, b, a + 1) P.eb(V[i]); } } return P; } // path [a,b] と [c,d] の交わり. 空ならば {-1,-1}. // https://codeforces.com/problemset/problem/500/G pair<int, int> path_intersection(int a, int b, int c, int d) { int ab = lca(a, b), ac = lca(a, c), ad = lca(a, d); int bc = lca(b, c), bd = lca(b, d), cd = lca(c, d); int x = ab ^ ac ^ bc, y = ab ^ ad ^ bd; // meet(a,b,c), meet(a,b,d) if (x != y) return {x, y}; int z = ac ^ ad ^ cd; if (x != z) x = -1; return {x, x}; } // uv path 上で check(v) を満たす最後の v // なければ (つまり check(v) が ng )-1 template <class F> int max_path(F check, int u, int v) { if (!check(u)) return -1; auto pd = get_path_decomposition(u, v, false); for (auto [a, b]: pd) { if (!check(V[a])) return u; if (check(V[b])) { u = V[b]; continue; } int c = binary_search([&](int c) -> bool { return check(V[c]); }, a, b, 0); return V[c]; } return u; } }; #line 2 "mod/modint61.hpp" struct modint61 { static constexpr u64 mod = (1ULL << 61) - 1; u64 val; constexpr modint61() : val(0ULL) {} constexpr modint61(u32 x) : val(x) {} constexpr modint61(u64 x) : val(x % mod) {} constexpr modint61(int x) : val((x < 0) ? (x + static_cast<ll>(mod)) : x) {} constexpr modint61(ll x) : val(((x %= static_cast<ll>(mod)) < 0) ? (x + static_cast<ll>(mod)) : x) {} static constexpr u64 get_mod() { return mod; } modint61 &operator+=(const modint61 &a) { val = ((val += a.val) >= mod) ? (val - mod) : val; return *this; } modint61 &operator-=(const modint61 &a) { val = ((val -= a.val) >= mod) ? (val + mod) : val; return *this; } modint61 &operator*=(const modint61 &a) { const unsigned __int128 y = static_cast<unsigned __int128>(val) * a.val; val = (y >> 61) + (y & mod); val = (val >= mod) ? (val - mod) : val; return *this; } modint61 operator-() const { return modint61(val ? mod - val : u64(0)); } modint61 &operator/=(const modint61 &a) { return (*this *= a.inverse()); } modint61 operator+(const modint61 &p) const { return modint61(*this) += p; } modint61 operator-(const modint61 &p) const { return modint61(*this) -= p; } modint61 operator*(const modint61 &p) const { return modint61(*this) *= p; } modint61 operator/(const modint61 &p) const { return modint61(*this) /= p; } bool operator<(const modint61 &other) const { return val < other.val; } bool operator==(const modint61 &p) const { return val == p.val; } bool operator!=(const modint61 &p) const { return val != p.val; } modint61 inverse() const { ll a = val, b = mod, u = 1, v = 0, t; while (b > 0) { t = a / b; swap(a -= t * b, b), swap(u -= t * v, v); } return modint61(u); } modint61 pow(ll n) const { assert(n >= 0); modint61 ret(1), mul(val); while (n > 0) { if (n & 1) ret *= mul; mul *= mul, n >>= 1; } return ret; } }; #ifdef FASTIO void rd(modint61 &x) { fastio::rd(x.val); assert(0 <= x.val && x.val < modint61::mod); } void wt(modint61 x) { fastio::wt(x.val); } #endif #line 4 "graph/ds/rolling_hash_on_tree.hpp" // 木の辺に文字がちょうどひとつ書いてある (static) template <typename TREE, bool EDGE> struct Rolling_Hash_On_Tree { using mint = modint61; TREE& tree; int N; mint base; // edge に文字があると思って // dp1: [root,v] // dp2: [v,root] vc<int> dat; vc<mint> dp1, dp2; vc<mint> pow, ipow; template <typename F> Rolling_Hash_On_Tree(TREE& tree, F f, mint base_ = 0) : tree(tree), N(tree.N), base(base_) { if (base == mint(0)) base = RNG(mint::get_mod()); build(f); } template <typename F> void build(F f) { dat.resize(N); if constexpr (EDGE) { FOR(i, N - 1) { dat[tree.e_to_v(i)] = f(i); } } else { FOR(i, N) { dat[i] = f(i); } } pow.resize(N + 1), ipow.resize(N + 1); pow[0] = 1, pow[1] = base; ipow[0] = 1, ipow[1] = base.inverse(); FOR(i, 2, N + 1) pow[i] = pow[i - 1] * pow[1]; FOR(i, 2, N + 1) ipow[i] = ipow[i - 1] * ipow[1]; int root = tree.V[0]; dp1.resize(N), dp2.resize(N); dp1[root] = dp2[root] = dat[0]; FOR(i, 1, N) { int v = tree.V[i]; int d = tree.depth[v], p = tree.parent[v]; dp1[v] = base * dp1[p] + dat[v]; dp2[v] = dp2[p] + pow[d] * dat[v]; } } mint get(int a, int b) { int c = tree.lca(a, b); mint x1 = get_du(a, c), x2 = get_ud(c, b); int n2 = tree.depth[b] - tree.depth[c]; if constexpr (!EDGE) { x1 = x1 * base + dat[c]; } return x1 * pow[n2] + x2; } int lcp(int s1, int t1, int s2, int t2) { return lcp_and_comp(s1, t1, s2, t2).fi; } // <=> char comp(int s1, int t1, int s2, int t2) { return lcp_and_comp(s1, t1, s2, t2).se; } pair<int, char> lcp_and_comp(int s1, int t1, int s2, int t2) { int lcp = 0; // heavy path の頂点列 auto path1 = tree.get_path_decomposition(s1, t1, EDGE); auto path2 = tree.get_path_decomposition(s2, t2, EDGE); reverse(all(path1)); reverse(all(path2)); while (len(path1) && len(path2)) { int a, b, c, d; tie(a, b) = POP(path1), tie(c, d) = POP(path2); ll n1 = abs(a - b) + 1, n2 = abs(c - d) + 1; ll n = min(n1, n2); if (n < n1) { if (a <= b) { path1.eb(a + n, b), b = a + n - 1; } if (a > b) { path1.eb(a - n, b), b = a - n + 1; } } if (n < n2) { if (c <= d) { path2.eb(c + n, d), d = c + n - 1; } if (c > d) { path2.eb(c - n, d), d = c - n + 1; } } mint x1 = from_hld_pair(a, b), x2 = from_hld_pair(c, d); if (x1 == x2) { lcp += n; continue; } auto check = [&](ll n) -> bool { if (n == 0) return 1; mint x1 = (a <= b ? from_hld_pair(a, a + n - 1) : from_hld_pair(a, a - n + 1)); mint x2 = (c <= d ? from_hld_pair(c, c + n - 1) : from_hld_pair(c, c - n + 1)); return x1 == x2; }; ll k = binary_search(check, 0, n); lcp += k; a = (a <= b ? a + k : a - k); c = (c <= d ? c + k : c - k); a = tree.V[a], c = tree.V[c]; if (dat[a] < dat[c]) return {lcp, '<'}; if (dat[a] == dat[c]) return {lcp, '='}; if (dat[a] > dat[c]) return {lcp, '>'}; } if (!path1.empty()) return {lcp, '>'}; if (!path2.empty()) return {lcp, '<'}; return {lcp, '='}; } private: mint get_ud(int a, int b) { return (a == -1 ? dp1[b] : dp1[b] - dp1[a] * pow[tree.depth[b] - tree.depth[a]]); } mint get_du(int a, int b) { return (b == -1 ? dp2[a] : (dp2[a] - dp2[b]) * ipow[tree.depth[b] + 1]); } mint from_hld_pair(int a, int b) { if (a <= b) { return get_ud(tree.parent[tree.V[a]], tree.V[b]); } return get_du(tree.V[a], tree.parent[tree.V[b]]); } };